"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _buttonview = _interopRequireDefault(require("@ckeditor/ckeditor5-ui/src/button/buttonview"));

var _plugin = _interopRequireDefault(require("@ckeditor/ckeditor5-core/src/plugin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class CodeSnippetUI extends _plugin.default {
  init() {
    const editor = this.editor;
    const t = editor.t; // The "codeSnippet" button must be registered among the UI components of the editor
    // to be displayed in the toolbar.

    editor.ui.componentFactory.add('codeSnippet', locale => {
      // The state of the button will be bound to the widget command.
      const command = editor.commands.get('insertCodeSnippet'); // The button will be an instance of ButtonView.

      const buttonView = new _buttonview.default(locale);
      buttonView.set({
        // The t() function helps localize the editor. All strings enclosed in t() can be
        // translated and change when the language of the editor changes.
        label: t('Code Snippet'),
        withText: true,
        tooltip: true
      }); // Bind the state of the button to the command.

      buttonView.bind('isOn', 'isEnabled').to(command, 'value', 'isEnabled'); // Execute the command when the button is clicked (executed).

      this.listenTo(buttonView, 'execute', () => editor.execute('insertCodeSnippet'));
      return buttonView;
    });
  }

}

exports.default = CodeSnippetUI;